class NoeudPriorite
{
	String s;
	int priorite;
	NoeudPriorite prec;
	NoeudPriorite suiv;

	NoeudPriorite(String chaine) {
		s = chaine;
		priorite = calcule(s);
		suiv = null;
		prec = null;
	}

	NoeudPriorite(String chaine, int prio) {
		s = chaine;
		priorite = prio;
		suiv = null;
		prec = null;
	}

	NoeudPriorite ajoute(String chaine) {
		NoeudPriorite noeud = new NoeudPriorite(chaine);
		return ajoute(noeud);
	}

	NoeudPriorite ajoute(String chaine, int prio) {
		return ajoute(new NoeudPriorite(chaine, prio));
	}

	NoeudPriorite ajoute(NoeudPriorite noeud) {
		if (noeud.priorite >= priorite) {
			noeud.suiv=this;
			return noeud; }
		else if (suiv == null) {
			suiv=noeud;
			return this; }
		else {
			suiv = suiv.ajoute(noeud);
			return this; }
	}

// fonction traduisant celle existant dja mais pour nos files de priorit :
// le noeud ne doit pas tre dans une chaine de plus de nb_maxi noeuds
	NoeudPriorite ajoute(NoeudPriorite noeud, int nb_maxi) {
		if (nb_maxi == 0) return null;

		if (noeud.priorite >= priorite) {
			noeud.suiv=this;
			return noeud; }
		else if (suiv == null) {
			suiv=noeud;
			return this; }
		else {
			suiv = suiv.ajoute(noeud);
			return this; }
	}

// fonction qui calcule pour un mot donn une "priorit de traitement" : dans le texte  dcrypter on va
// prfrer dcrypter d'abord les mots les plus longs ou avec le plus d'occurences de meme caractre
	static int calcule(String s) {
		int[] t = new int[26];
		for(int k = 0; k < s.length(); k++)
			t[s.charAt(k) - 'a']++;
		
		int summ = 0;
		for(int k = 0; k < 26; k++)
			summ += t[k] * t[k];
		return summ;
	}
	
	public void affiche() {
		System.out.println(s + " " + priorite);
		if (suiv != null) suiv.affiche();
	}
}